#!/bin/sh

#
# Copyright (c) 2003 Brocade Communications Systems, Inc.
# All rights reserved.
#
# Description:
#   <Insert Description Here>
#
#
# Copyright (c) 1997-2000 The NetBSD Foundation, Inc.
# All rights reserved.
#
# This code is derived from software contributed to The NetBSD Foundation
# by Luke Mewburn.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#        This product includes software developed by the NetBSD
#        Foundation, Inc. and its contributors.
# 4. Neither the name of The NetBSD Foundation nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#


#
#
# INTERNAL INSTRUCTIONS:
#
#   <Insert Instructions Here>
#
# Refer to base.xml for specific information on which stages you need to support.
#
#
# 
# STAGES                                                                 MOST-LIKELY REQUIRED FOR
# --------------------------------------------------------------------------------------------------
# pre_package    -  Invoked on build machine                             SERVICE-GROUP
# post_package   -  Invoked on build machine                             SERVICE-GROUP
# pre_install    -  Invoked before upgrade/downgrade                     SERVICE-GROUP  
# post_install   -  Invoked after  upgrade/downgrade                     SERVICE-GROUP  
# pre_ndsu       -  Invoked before non-disruptive upgrade                SERVICE-GROUP  
# post_ndsu      -  Invoked after  non-disruptive upgrade                SERVICE-GROUP  
# pre_uninstall  -  Invoked before files are removed                     SERVICE-GROUP
# post_uninstall -  Invoked after  files are removed                     SERVICE-GROUP
# boot           -  Invoked during switch bootup                         RESERVED
# startup        -  Startup  SID                                         SERVICE, SERVICE-GROUP
# shutdown       -  Shutdown SID                                         SERVICE, SERVICE-GROUP
# restart        -  Graceful restart if possible (shutdown->startup)     SERVICE, SERVICE-GROUP
#
#
# GLOBAL READ-ONLY variables
# --------------------------------------------------------------------------------------------------
# $STAGE      - See above 
# $SID        - Service ID (see RPG xml)
# $VERSION    - Version Identifier (see RPG xml) 
# $BIN_PATH   - (i.e. /usr/pkg/bin)
# $SBIN_PATH  - (i.e. /usr/pkg/sbin)
# $RCD_PATH   - (i.e. /usr/pkg/etc/rc.d)  // For backwards compatibility purposes 
# $ETC_PATH   - (i.e. /usr/pkg/etc)
# 
# HELPER FUNCTIONS
# --------------------------------------------------------------------------------------------------
#
# Note: Helper Functions do not take arguments in the event we migrate to a /etc/rc.d/ style
# methodology.
#
#    REQUIRED HELPER VARIABLES FOR HELPER FUNCTIONS
#    ---------------------------------------------------------
#    $_procpath - pathname (i.e. /usr/pkg/bin) 
#    $_progname - argv[0] of binary / listed in process table 
#    $_progargs - program arguments
#
# 
#
# startup__  : Starts Application
#    
#    if [ -f progname ] ; then
#       exec $_progname $_progargs
#    fi
#
# shutdown__ : Kills Application according to process name
#
#    ps | grep $_progname | kill -TERM  # NASTY
#   
# restart__  : Shutsdown and then restarts
#
#    eval shutdown__ 
#    eval startup__
#
#
#

# Define return codes here.
SUCCESS=0
RK_UPGRADE_REQUIRED=22

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: com
#

com_pre_package() {
}    

com_post_package() {
}

com_pre_install() {
}

com_post_install() {
}

com_pre_upgrade() {
}

com_post_upgrade() {
}

com_pre_uninstall() {
}

com_post_uninstall() {
}

com_startup() {
}

com_shutdown() {
}

com_restart() {
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: RHAPSODY
# 

rhapsody_pre_package() {
}    

rhapsody_post_package() {
}

rhapsody_pre_install() {
}

rhapsody_post_install() {
}

rhapsody_pre_upgrade() {
}

rhapsody_post_upgrade() {
}

rhapsody_pre_uninstall() {
}

rhapsody_post_uninstall() {
}

rhapsody_startup() {
}

rhapsody_shutdown() {
}

rhapsody_restart() {
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: BASE
# 

base_pre_package() {
}    

base_post_package() {
    # XXX 
    # XXX this was taken from rhapsody.sh - system_scripts SID ???
    # XXX
}

base_pre_install() {
}

base_post_install() {
	cd ${FSROOT}
	chown -R root:wheel * 
    if [ -d /usr/pkg/webroot/fastcgi ]; then
	    chown -R nobody:nobody /usr/pkg/webroot/fastcgi
    fi

    # fix for new bootloader code
    nv get xpathboot1            > .boot_ld
    nv set xpathboot1 mem:self  >> .boot_ld
    nv get xpathboot1           >> .boot_ld

    $SBIN_PATH/nv get installstate          > .nipen
    $SBIN_PATH/nv set installstate 2       >> .nipen
    $SBIN_PATH/nv get installstate         >> .nipen

    # set for bootloader work
    $SBIN_PATH/nv get watchdog_timeout     > .guys
    $SBIN_PATH/nv set watchdog_timeout 0   >> .guys
    $SBIN_PATH/nv get watchdog_timeout     >> .guys
}

base_pre_upgrade() {
}

base_post_upgrade() {

    
    # Bug avoidance 

    if [ ! -f /rpgtemp/postudmerge.xml ]; then
	exit 0
    fi 

    if [ ! -f /rpgtemp/preudmerge.xml ]; then
	exit 0
    fi

    # First shutdown od heartbeats

    _progpath="$BIN_PATH" 
    _progname="od"
    eval shutdown__

    _progpath="$BIN_PATH" 
    _progname="ud"
    eval shutdown__

    /bin/cp /rpgtemp/postudmerge.xml /etc/rpgxml/postudmerge.xml
    /bin/cp /rpgtemp/preudmerge.xml  /etc/rpgxml/preudmerge.xml

    /bin/sync
    /bin/sync
    /bin/sync
    sleep 10  
    /usr/pkg/bin/ud -v -s /rpgtemp/postudmerge.xml -r /rpgtemp/preudmerge.xml -l /var/log/lastupgrade.txt

    if [ "$?" = "0" ] ; then
	# Upgrade success!

	/usr/pkg/bin/od -h 60 heartbeat
    else
	###  Upgrade Failure

	sleep 10
	/usr/pkg/bin/od shutdown

	if [ "$?" = 0 ]; then    
	    sleep 10
	    /usr/pkg/bin/od startup
	fi

	if [ "$?" = 0 ]; then
	    sleep 10
	    /usr/pkg/bin/od -h 60 heartbeat	
	fi    
    fi
    
}

base_pre_uninstall() {
}

base_post_uninstall() {
}

base_startup() {
}

base_shutdown() {
}

base_restart() {
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: SYSTEM
#    

fs_pre_install()
{

  # if in recovery kernel and no password file present(clean install), quit
  if [ ! -f ${FSROOT}/etc/passwd ]; then
    exit 0
  fi

  cd ${FSROOT}

  # lets move over the existing password
  # configuration
  cp -p ${FSROOT}/etc/master.passwd  ${FSROOT}/etc/master.passwd.save
  cp -p ${FSROOT}/etc/passwd  ${FSROOT}/etc/passwd.save
  cp -p ${FSROOT}/etc/spwd.db ${FSROOT}/etc/spwd.db.save
  cp -p ${FSROOT}/etc/pwd.db  ${FSROOT}/etc/pwd.db.save
  cp -p ${FSROOT}/etc/group   ${FSROOT}/etc/group.save
}


fs_post_install()
{
  # if in recovery kernel and no password file present(clean install), quit
  if [ -f ${FSROOT}/etc/master.passwd ]; then

  	cd ${FSROOT}

  	# lets move over the existing password
  	# configuration
  	cp -p ${FSROOT}/etc/master.passwd  ${FSROOT}/etc/master.passwd.save
  	cp -p ${FSROOT}/etc/passwd  ${FSROOT}/etc/passwd.save
  	cp -p ${FSROOT}/etc/spwd.db ${FSROOT}/etc/spwd.db.save
  	cp -p ${FSROOT}/etc/pwd.db  ${FSROOT}/etc/pwd.db.save
  	cp -p ${FSROOT}/etc/group   ${FSROOT}/etc/group.save
  fi

  cd ${FSROOT}
  pax -z -r -f new_root.pax.bz2
  [ -f new_root.pax.bz2 ] && rm -f new_root.pax.bz2
  pax -z -r -f brocade.pax.bz2
  [ -f brocade.pax.bz2 ] && rm -f brocade.pax.bz2

  # lets restore password configuration if its there
  if [ ! -f ${FSROOT}/etc/master.passwd.save ]; then
    exit 0
  fi
  cp -p ${FSROOT}/etc/master.passwd.save  ${FSROOT}/etc/master.passwd
  cp -p ${FSROOT}/etc/passwd.save  ${FSROOT}/etc/passwd
  cp -p ${FSROOT}/etc/spwd.db.save ${FSROOT}/etc/spwd.db
  cp -p ${FSROOT}/etc/pwd.db.save  ${FSROOT}/etc/pwd.db
  cp -p ${FSROOT}/etc/group.save   ${FSROOT}/etc/group

}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: CHASSIS
# 

chassis_pre_package() {
}    

chassis_post_package() {
}

chassis_pre_install() {
}

chassis_post_install() {
}

chassis_pre_upgrade() {
}

chassis_post_upgrade() {
}

chassis_pre_uninstall() {
}

chassis_post_uninstall() {
}

chassis_startup() {
}

chassis_shutdown() {
}

chassis_restart() {
}

ud_post_install() {
    cp /usr/pkg/bin/ud /usr/pkg/bin/overseerd
}


# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: FC
# 

fc_pre_package() {
}    

fc_post_package() {
}

fc_pre_install() {
}

fc_post_install() {
}

fc_pre_upgrade() {
}

fc_post_upgrade() {
}

fc_pre_uninstall() {
}

fc_post_uninstall() {
}

fc_startup() {
}

fc_shutdown() {
}

fc_restart() {
}



# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: IPS
# 

ips_pre_package() {
}    

ips_post_package() {
}

ips_pre_install() {
}

ips_post_install() {
}

ips_pre_upgrade() {
}

ips_post_upgrade() {
}

ips_pre_uninstall() {
}

ips_post_uninstall() {
}

ips_startup() {
}

ips_shutdown() {
}

ips_restart() {
}


# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: ISW 
# 

isw_pre_package() {
}    

isw_post_package() {
}

isw_pre_install() {
}

isw_post_install() {
}

isw_pre_upgrade() {
}

isw_post_upgrade() {
}

isw_pre_uninstall() {
}

isw_post_uninstall() {
}

isw_startup() {
}

isw_shutdown() {
}

isw_restart() {
}


# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: RPC 
# 

rpc_pre_package() {
}    

rpc_post_package() {
}

rpc_pre_install() {
}

rpc_post_install() {
}

rpc_pre_upgrade() {
}

rpc_post_upgrade() {
}

rpc_pre_uninstall() {
}

rpc_post_uninstall() {
}

rpc_startup() {
}

rpc_shutdown() {
}

rpc_restart() {
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: webroot
# 

webroot_pre_package() {
    stage_dir="${TMP_RPG_DIR}/webroot"
    src_root="${SRC_ROOT}"
    webfiles_target="/usr/pkg/webroot"
    webfiles_source="${src_root}/../webroot"    
    xmlrpc_so_source="${BUILD_ROOT}/cm/ppc/lib"
    weblinker_source="${BUILD_ROOT}/cm/ppc/daemons"
    weblinker_target="/usr/pkg/bin"
    apache_lib_source="${src_root}/../thirdparty/apache/lib"
    apache_source="${src_root}/../thirdparty/apache/usr/pkg/apache"
    apache_target="/usr/pkg/apache"
    apache_rc_source="${src_root}/../thirdparty/apache/rc"

    rm -fr ${stage_dir}
    rm ${TMP_RPG_DIR}/webroot.pax*

    mkdir -p ${stage_dir}
    mkdir -p ${stage_dir}/${webfiles_target}
    mkdir -p ${stage_dir}/${webfiles_target}/log
    mkdir -p ${stage_dir}/${webfiles_target}/conf
    mkdir -p ${stage_dir}/${weblinker_target}
    mkdir -p ${stage_dir}/usr/pkg/lib
    mkdir -p ${stage_dir}/usr/lib
    mkdir -p ${stage_dir}/${apache_target}

    cd ${src_root}/../webroot
    
    cp ${apache_lib_source}/libexpat.* ${stage_dir}/usr/pkg/lib/
    cp ${src_root}/../thirdparty/abyss/conf/mime.types \
        ${stage_dir}/${webfiles_target}/conf/

    mkdir -p ${stage_dir}/${RCD_PATH}
    cp ${apache_rc_source}/*  ${stage_dir}/${RCD_PATH}/.

    # copy weblinker.fcg and proxy.fcg
    cp ${weblinker_source}/*.fcg ${stage_dir}/${weblinker_target}

    # copy everything under webroot (minus the 'CVS' stuff)
    # first the directories
    cd ${webfiles_source}
    for i in `find . -type d ! -regex '^.*CVS.*$' -print`;do
        mkdir -p ${stage_dir}/${webfiles_target}/$i; \
        chmod 755 ${stage_dir}/${webfiles_target}/${i}
    done
    # and the files in them
    cd ${webfiles_source}
    for i in `find . -type f ! -regex '^.*CVS.*$' -print`;do
        cp $i ${stage_dir}/${webfiles_target}/${i}; \
        chmod 644 ${stage_dir}/${webfiles_target}/${i}
    done
    
    # copy everything under apache directory
    # make directories first
    cd ${apache_source}
    for i in `find . -type d ! -regex '^.*CVS.*$' -print`;do
	mkdir -p ${stage_dir}/${apache_target}/$i; \
	chmod 755 ${stage_dir}/${apache_target}/${i}
    done
    # now copy the files from those directories    
    cd ${apache_source}
    for i in `find . -type f ! -regex '^.*CVS.*$' -print`;do
    	cp $i ${stage_dir}/${apache_target}/${i};
    done

    cp ${xmlrpc_so_source}/libxml*.so* ${stage_dir}/usr/lib/.
    cd ${stage_dir}
    pax -v -w -f ${TMP_RPG_DIR}/webroot/../webroot.pax .
    bzip2 ${TMP_RPG_DIR}/webroot.pax
}

webroot_post_package() {
}

webroot_pre_install() {
}

webroot_post_install() {
  cd ${FSROOT}
  pax -z -r -f ${FSROOT}/usr/pkg/webroot/webroot.pax.bz2
  rm ${FSROOT}/usr/pkg/webroot/webroot.pax.bz2
  # remove old httpd binary from sbin
  rm -f /usr/pkg/sbin/httpd
  # remove old etc/httpd directory
  rm -rf /usr/pkg/etc/httpd
}

webroot_pre_upgrade() {
}

webroot_post_upgrade() {
}

webroot_pre_uninstall() {
}

webroot_post_uninstall() {
}

webroot_startup() {  
}

webroot_shutdown() {
}

webroot_restart() {
}


#
# SERVICE SID: overseer
#

overseer_boot() {
    # Special Case
    _progpath="$BIN_PATH" 
    _progname="overseer"
    _progargs="-s"    
    eval startup__
}

overseer_startup() {
    # THIS IS THE RESTART CASE
    _progpath="$BIN_PATH" 
    _progname="overseer"
    _progargs="-e"    
    eval startup__
}

overseer_shutdown() {
    # XXX this is not right since od is a special case
    # and must shutdown all other daemons

    _progpath="$BIN_PATH" 
    _progname="overseer"
    _progargs="-s"
    eval shutdown__
}

overseer_restart() {
    # XXX restart special case
    # -e inherit ud

    _progpath="$BIN_PATH" 
    _progname="overseer"
    _progargs="-e"
    eval restart__
}


#
# SERVICE SID: sb
#

sb_startup() {
    _progpath="$BIN_PATH" 
    _progname="sb"
    _progargs=""
    eval startup__
}

sb_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="sb"
    _progargs=""
    eval shutdown__
}

sb_restart() {
    _progpath="$BIN_PATH" 
    _progname="sb"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: objmgr
#

objmgr_startup() {
    _progpath="$BIN_PATH" 
    _progname="objmgr"
    _progargs=""
    eval startup__
}

objmgr_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="objmgr"
    _progargs=""
    eval shutdown__
}

objmgr_restart() {
    _progpath="$BIN_PATH" 
    _progname="objmgr"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: evtmgr
#

evtmgr_startup() {
    _progpath="$BIN_PATH" 
    _progname="evtmgr"
    _progargs=""
    eval startup__
}

evtmgr_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="evtmgr"
    _progargs=""
    eval shutdown__
}

evtmgr_restart() {
    _progpath="$BIN_PATH" 
    _progname="evtmgr"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: chassismgr
#

chassismgr_startup() {
    _progpath="$BIN_PATH" 
    _progname="chassisd"
    _progargs=""
    eval startup__
}

chassismgr_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="chassisd"
    _progargs=""
    eval shutdown__
}

chassismgr_restart() {
    _progpath="$BIN_PATH" 
    _progname="chassisd"
    _progargs=""
    eval restart__
}


#
# SERVICE SID: chassispd
#

chassispd_startup() {

    _progpath="$BIN_PATH" 
    _progname="chassispd"

    prealphahw="`getparams prealphahw`"
    if [ "$prealphahw" = "1" ]; then
	_progargs="-v"
    else
	_progargs=""
    fi

    eval startup__
}

chassispd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="chassispd"

    prealphahw="`getparams prealphahw`"
    if [ "$prealphahw" = "1" ]; then
	_progargs="-v"
    else
	_progargs=""
    fi

    eval shutdown__
}

chassispd_restart() {
    _progpath="$BIN_PATH" 
    _progname="chassispd"

    prealphahw="`getparams prealphahw`"
    if [ "$prealphahw" = "1" ]; then
	_progargs="-v"
    else
	_progargs=""
    fi

    eval restart__
}


#
# SERVICE SID: diagd
#

diagd_startup() {
    _progpath="$BIN_PATH" 
    _progname="diagd"
    _progargs="-d"
    eval startup__
}

diagd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="diagd"
    _progargs="-d"
    eval shutdown__
}

diagd_restart() {
    _progpath="$BIN_PATH" 
    _progname="diagd"
    _progargs="-d"
    eval restart__
}



#
# SERVICE SID: cpmgr
#

cpmgr_startup() {
    _progpath="$BIN_PATH" 
    _progname="cpmgr"
    _progargs="-D -r"
    eval startup__
}

cpmgr_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="cpmgr"
    _progargs="-D -r"
    eval shutdown__
}

cpmgr_restart() {
    _progpath="$BIN_PATH" 
    _progname="cpmgr"
    _progargs="-D -r"
    eval restart__
}

#
# SERVICE SID: rtd
#

rtd_startup() {
    _progpath="$BIN_PATH" 
    _progname="rtd"
    _progargs=""
    eval startup__
}

rtd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="rtd"
    _progargs=""
    eval shutdown__
}

rtd_restart() {
    _progpath="$BIN_PATH" 
    _progname="rtd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: iomctlr
#

iomctlr_startup() {
    _progpath="$BIN_PATH" 
    _progname="iomctlr"
    _progargs="-s -f 22 -g 100 -r 1"
    eval startup__
}

iomctlr_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="iomctlr"
    _progargs="-s -f 22 -g 100 -r 1"
    eval shutdown__
}

iomctlr_restart() {
    _progpath="$BIN_PATH" 
    _progname="iomctlr"
    _progargs="-s -f 22 -g 100 -r 1"
    eval restart__
}

#
# SERVICE SID: nsd
#

nsd_startup() {
    _progpath="$BIN_PATH" 
    _progname="nsd"
    _progargs=""
    eval startup__
}

nsd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="nsd"
    _progargs=""
    eval shutdown__
}

nsd_restart() {
    _progpath="$BIN_PATH" 
    _progname="nsd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: zsd
#

zsd_startup() {
    _progpath="$BIN_PATH" 
    _progname="zsd"
    _progargs=""
    eval startup__
}

zsd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="zsd"
    _progargs=""
    eval shutdown__
}

zsd_restart() {
    _progpath="$BIN_PATH" 
    _progname="zsd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: fcsald
#

fcsald_startup() {
    _progpath="$BIN_PATH" 
    _progname="fcsald"
    _progargs=""
    eval startup__
}

fcsald_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="fcsald"
    _progargs=""
    eval shutdown__
}

fcsald_restart() {
    _progpath="$BIN_PATH" 
    _progname="fcsald"
    _progargs=""
    eval restart__
}

fcsald_post_install() {
    ln -sf ${BIN_PATH}/fcvid ${BIN_PATH}/fcsald
}

#
# SERVICE SID: fabctl
#

fabctl_startup() {
    _progpath="$BIN_PATH" 
    _progname="fabctl"
    _progargs=""
    eval startup__
}

fabctl_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="fabctl"
    _progargs=""
    eval shutdown__
}

fabctl_restart() {
    _progpath="$BIN_PATH" 
    _progname="fabctl"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: iswitchd 
#

iswitchd_startup() {
    _progpath="$BIN_PATH" 
    _progname="iswitchd"
    _progargs=""
    eval startup__
}

iswitchd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="iswitchd"
    _progargs=""
    eval shutdown__
}

iswitchd_restart() {
    _progpath="$BIN_PATH" 
    _progname="iswitchd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: rcsd
#

rcsd_startup() {
    _progpath="$BIN_PATH" 
    _progname="rcsd"
    _progargs=""
    eval startup__
}

rcsd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="rcsd"
    _progargs=""
    eval shutdown__
}

rcsd_restart() {
    _progpath="$BIN_PATH" 
    _progname="rcsd"
    _progargs=""
    eval restart__
}


#
# SERVICE SID: msd
#

msd_startup() {
    _progpath="$BIN_PATH" 
    _progname="msd"
    _progargs=""
    eval startup__
}

msd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="msd"
    _progargs=""
    eval shutdown__
}

msd_restart() {
    _progpath="$BIN_PATH" 
    _progname="msd"
    _progargs=""
    eval restart__
}


#
# SERVICE SID: licensed
#

licensed_startup() {
    _progpath="$BIN_PATH" 
    _progname="licensed"
    _progargs=""
    eval startup__
}

licensed_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="licensed"
    _progargs=""
    eval shutdown__
}

licensed_restart() {
    _progpath="$BIN_PATH" 
    _progname="licensed"
    _progargs=""
    eval restart__
}


#
# SERVICE SID: fcipd
#

fcipd_startup() {
    _progpath="$BIN_PATH" 
    _progname="fcipd"
    _progargs=""
    eval startup__
}

fcipd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="fcipd"
    _progargs=""
    eval shutdown__
}

fcipd_restart() {
    _progpath="$BIN_PATH" 
    _progname="fcipd"
    _progargs=""
    eval restart__
}



#
# SERVICE SID: igd
#

igd_startup() {
    _progpath="$BIN_PATH"
    _progname="igd"
    _progargs=""
    eval startup__
}

igd_shutdown() {
    _progpath="$BIN_PATH"
    _progname="igd"
    _progargs=""
    eval shutdown__
}

igd_restart() {
    _progpath="$BIN_PATH"
    _progname="igd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: itd
#

itd_startup() {
    _progpath="$BIN_PATH"
    _progname="itd"
    _progargs=""
    eval startup__
}

itd_shutdown() {
    _progpath="$BIN_PATH"
    _progname="itd"
    _progargs=""
    eval shutdown__
}

itd_restart() {
    _progpath="$BIN_PATH"
    _progname="itd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: isnscd
#

isnscd_startup() {
    _progpath="$BIN_PATH"
    _progname="isnscd"
    _progargs=""
    eval startup__
}

isnscd_shutdown() {
    _progpath="$BIN_PATH"
    _progname="isnscd"
    _progargs=""
    eval shutdown__
}

isnscd_restart() {
    _progpath="$BIN_PATH"
    _progname="isnscd"
    _progargs=""
    eval restart__
}


#
# SERVICE SID: fcitd
#
fcitd_post_install() {
}

#
# SERVICE SID: xmld
#

xmld_startup() {
    _progpath="$BIN_PATH" 
    _progname="xmld"
    _progargs=""
    eval startup__
}

xmld_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="xmld"
    _progargs=""
    eval shutdown__
}

xmld_restart() {
    _progpath="$BIN_PATH" 
    _progname="xmld"
    _progargs=""
    eval restart__
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP: diags
#
diag_port_images_pre_package() {
    export diag_portimage_source="${BUILD_ROOT}/port/figero_xbartst"
    export diag_portimage_source2="${BUILD_ROOT}/port/figero_memtst"
    export diag_portimage_source3="${BUILD_ROOT}/port/figero_mboxtst"
    export diag_portimage_source4="${BUILD_ROOT}/port/figero_wiretst"
    export diag_portimage_source5="${BUILD_ROOT}/port/figero_bm"
    export diag_portimage_source6="${BUILD_ROOT}/port/figero_gbtst"
    export diag_portimages="xbartst.a*"
    export diag_portimages2="memtst.a*"
    export diag_portimages3="mboxtst.a*"
    export diag_portimages4="wiretst.a*"
    export diag_portimages5="bm.a*"
    export diag_portimages6="gbtst.a*"
    export diag_portimage_target="tftpboot/figero/"


    mkdir -p ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}
    cp ${diag_portimage_source}/${diag_portimages} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cp ${diag_portimage_source2}/${diag_portimages2} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cp ${diag_portimage_source3}/${diag_portimages3} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cp ${diag_portimage_source4}/${diag_portimages4} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cp ${diag_portimage_source5}/${diag_portimages5} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cp ${diag_portimage_source6}/${diag_portimages6} ${TMP_RPG_DIR}/diag_port_images/${diag_portimage_target}/.
    cd ${TMP_RPG_DIR}/${SID}
    pax -w -f ../${SID}.pax .
}

diag_port_images_post_install() {
    cd ${FSROOT}
    pax -r -f ${FSROOT}/tftpboot/figero/diag_port_images.pax
    rm -f ${FSROOT}/tftpboot/figero/diag_port_images.pax
}

# --------------------------------------------------------------------------------------------------
# SERVICE-SID: diagcli
#

diagcli_post_install() {

        mkdir -p ${FSROOT}/usr/pkg/diagscripts/cmddir
        
        cd ${FSROOT}/usr/pkg/sbin
        
        mv cellomemtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv gmac2bridgetest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv ledtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv asicrevshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagmode ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv sepromtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagvoltshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagfanshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagsfpshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagtempshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagpsshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagsetfanspeed ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagchassissnshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
        mv diagboardsnshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
                        
}

# --------------------------------------------------------------------------------------------------
# SERVICE-SID: mfg_diag
#
mfg_diag_pre_package() {

        rm -f ${TMP_RPG_DIR}/${SID}.pax
        rm -fr ${TMP_RPG_DIR}/${SID}
        mkdir -p ${TMP_RPG_DIR}/${SID}
                mkdir -p ${TMP_RPG_DIR}/${SID}/cmddir
        cd ${SRC_ROOT}/switch/imgmt/cli/diagscripts/cmddir
        cp * ${TMP_RPG_DIR}/${SID}/cmddir/.
                mkdir -p ${TMP_RPG_DIR}/${SID}/share
        cd ${SRC_ROOT}/switch/imgmt/cli/diagscripts/share
        cp * ${TMP_RPG_DIR}/${SID}/share/.

        cd ${TMP_RPG_DIR}/${SID}
        pax -v -x sv4crc -w -f ../${SID}.pax .
}

mfg_diag_post_install() {

        cd ${FSROOT}/usr/pkg/diagscripts
        pax -r -p e -f ${SID}.pax
        [ -f ${SID}.pax ] && rm -f ${SID}.pax
                
        chmod 755 ${FSROOT}/usr/pkg/diagscripts/cmddir/*
        chmod 755 ${FSROOT}/usr/pkg/diagscripts/share/*
        
        cd ${FSROOT}/usr/pkg/diagscripts/share
        rm switchess.sh
        rm switchrunin.sh
        mv diagsetcycle ${FSROOT}/usr/pkg/sbin/.
        mv diagsetburnin ${FSROOT}/usr/pkg/sbin/.
        mv diagstopburnin ${FSROOT}/usr/pkg/sbin/.
        mv burninerrshow ${FSROOT}/usr/pkg/sbin/.
        mv burninstatus ${FSROOT}/usr/pkg/sbin/.
        
        cd ${FSROOT}/usr/pkg/diagscripts/cmddir
        rm voltagemargin.sh
        
}

# --------------------------------------------------------------------------------------------------
# SERVICE-GROUP SID: mfg
# 

# 
# SERVICE SID: mfgdiag
# 

mfgdiag_pre_package() {
        rm -f ${TMP_RPG_DIR}/${SID}.pax
        rm -fr ${TMP_RPG_DIR}/${SID}
        mkdir -p ${TMP_RPG_DIR}/${SID}
		mkdir -p ${TMP_RPG_DIR}/${SID}/fabos
		mkdir -p ${TMP_RPG_DIR}/${SID}/fabos/cmddir
        cd ${SRC_ROOT}/tools/diag_tools/mfg/fabos/cmddir
        cp * ${TMP_RPG_DIR}/${SID}/fabos/cmddir/.
		mkdir -p ${TMP_RPG_DIR}/${SID}/fabos/share
        cd ${SRC_ROOT}/tools/diag_tools/mfg/fabos/share
        cp * ${TMP_RPG_DIR}/${SID}/fabos/share/.

        mkdir -p ${TMP_RPG_DIR}/${SID}/script
		mkdir -p ${TMP_RPG_DIR}/${SID}/script/image
        cd ${SRC_ROOT}/tools/diag_tools/mfg/script/image
        cp * ${TMP_RPG_DIR}/${SID}/script/image/.

        cd ${TMP_RPG_DIR}/${SID}
        pax -v -x sv4crc -w -f ../${SID}.pax .
}

mfgdiag_post_install() {
    cd ${FSROOT}
	pax -r -p e -f ${SID}.pax
	rm -f ${SID}.pax
}

# --------------------------------------------------------------------------------------------------
# NON-CHA SERVICES
#


#
# SERVICE SID: apache
#

apachebin_startup() {    
    chmod u+s /usr/pkg/bin/*.fcg
	if [ -f /usr/pkg/apache/logs/httpd.pid ] ; then
		echo -n > /usr/pkg/apache/logs/httpd.pid
	fi
    exec $RCD_PATH/apache start
}

apachebin_shutdown() {
    exec $RCD_PATH/apache stop
}

apachebin_restart() {
    chmod u+s /usr/pkg/bin/*.fcg
    exec $RCD_PATH/apache restart
}

apachebin_status() {
    # return 0 for OK
    # return 1 for FAILED
    exec $RCD_PATH/apache status
}

#
# SERVICE SID: sd
#

sd_startup() {
    exec $RCD_PATH/sd start
}

sd_shutdown() {
    exec $RCD_PATH/sd stop
}

sd_restart() {
    exec $RCD_PATH/sd restart
}

#
# SERVICE SID: snmpd
#

snmpd_startup() {
    exec $RCD_PATH/snmpd start
}

snmpd_shutdown() {
    exec $RCD_PATH/snmpd stop
}

snmpd_restart() {
    exec $RCD_PATH/snmpd restart
}




#
# SERVICE SID: iscsi
# 

iscsi_ips_post_install() {

	#copy the commandslist and config files first to make sure that they are from this build
	if [ -f ${ETC_PATH}/admin.commandslist ]
	then
		cp ${ETC_PATH}/admin.commandslist ${ETC_PATH}/admin.commandslist.orig
		cp ${ETC_PATH}/user.commandslist ${ETC_PATH}/user.commandslist.orig
	fi
	
	if [ -f ${ETC_PATH}/admin.config ]
	then
		cp ${ETC_PATH}/admin.config ${ETC_PATH}/admin.config.orig
		cp ${ETC_PATH}/user.config ${ETC_PATH}/user.config.orig
	fi

    # Enable iSCSI by default
    $SBIN_PATH/nv set servicemap 1
}

iscsi_scripts_post_install() {
       chmod 755 $ETC_PATH/rc.d/iscsi_enadis
}



iscsi_startup() {
    exec $RCD_PATH/iscsid start
}

iscsi_shutdown() {
    exec $RCD_PATH/iscsid stop
}

iscsi_restart() {
    exec $RCD_PATH/iscsid restart
}

#
# SERVICE GROUP SID: chkrkver
#

chkrkver_post_install() {

if [ ${FSROOT} != "/rt_root" ]
then
	$SBIN_PATH/nv set installstate 1
fi
	
	#Check recovery version compatibility.
    rkversion=`getparams bank0ver`
	if [ ${rkversion} \> "1.3.0.1" ]
	then
		exit ${SUCCESS}
	else
		#Hack for recovery kernel, since rpg is not self-upgraded from RK.
		if [ ${FSROOT} = "/rt_root" ]
		then
			#rpgpid=`ps | grep rpg | grep -v grep`
			#rpgpid=${rpgpid%%" "*}
			echo "INCOMPATIBLE RECOVERY KERNEL. SYSTEM GOING DOWN FOR REBOOT IN 3 SECONDS. PLEASE UPGRADE RECOVERY KERNEL BEFORE INSTALLING BASE OS."
			#exec kill -9 $rpgpid
			sleep 3 
			exec reboot
		fi
		exit ${RK_UPGRADE_REQUIRED}
	fi		
}

#
# SERVICE SID: rpcd
# 

rpcd_startup() {
    _progpath="$BIN_PATH" 
    _progname="rpcd"
    _progargs=""
    eval startup__
}

rpcd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="rpcd"
    _progargs=""
    eval shutdown__
}

rpcd_restart() {
    _progpath="$BIN_PATH" 
    _progname="rpcd"
    _progargs=""
    eval restart__
}

#
# SERVICE SID: arrd
#
arrd_startup() {
    _progpath="$BIN_PATH" 
    _progname="arrd"
    _progargs=""
    eval startup__
}

arrd_shutdown() {
    _progpath="$BIN_PATH" 
    _progname="arrd"
    _progargs=""
    eval shutdown__
}

arrd_restart() {
    _progpath="$BIN_PATH" 
    _progname="arrd"
    _progargs=""
    eval restart__
}

#
# INTERNAL SCRIPT TEST SID: test
#

test_startup() {
    _progpath="/usr/bin"
    _progname="less"
    _progargs="/etc/passwd"
    eval startup__
}

test_shutdown() {
    _progpath="/usr/bin"
    _progname="less"
    _progargs="/etc/passwd"
    shutdown__
}

test_restart() {
    _progpath="/usr/bin"
    _progname="less"
    _progargs="/etc/passwd"
    eval restart__
}


#
# COMMON FUNCTIONS
#
#
#


# 
# usage
#   Prints usage 
#
#

usage__()
{
    echo "Usage: $0 STAGE SID VERSION"
    exit 1
}

startup__()
{
    if [ -f "$_progpath/$_progname" ] ; then
	exec $_progpath/$_progname $_progargs
    else
        echo "Error: $_progname not found."
	exit 2
    fi
}

restart__()
{
    eval shutdown__
    eval startup__
}

shutdown__()
{
    # XXX : Performance Problem
    #    _pids=`eval check_process__ $_progpath/$_progname`
    #    wait_for_pids__ $_pids

    _pids=`eval check_process__ $_progname`
    wait_for_pids__ $_pids
}


#
# NetBSD: /etc/rc.subr modified
#

check_process__()
{
	_procname=$1
	echo $_procname
	if [ -z "$_procname" ]; then
		err 3 'USAGE: check_process procname'
	fi
	_procnamebn=${_procname##*/}
	_pref=
#	ps -ax -o 'pid,command' | while read _npid _arg0 _argv; do
	ps -ax -o 'pid,ucomm' | while read _npid _arg0 _argv; do
		case "$_npid" in
		    PID)
			continue ;;
		esac
		case "$_arg0" in
		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|/$_procname)
			echo -n "$_pref$_npid"
			_pref=" "
			;;
		esac
	done
}


#
# NetBSD: /etc/rc.subr modified
#

wait_for_pids__()
{
	_list=$*
	if [ -z "$_list" ]; then
		return
	fi
	_prefix=
	while true; do
		_nlist="";
		for _j in $_list; do
			if kill -9 $_j 2>/dev/null; then
				_nlist="${_nlist}${_nlist:+ }$_j"
			fi
		done
		if [ -z "$_nlist" ]; then
			break
		fi
		_list=$_nlist
		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
		_prefix=", "

		### XXXX treacherous for OD

		sleep 1
	done
	if [ -n "$_prefix" ]; then
		echo -n "."
	fi
}


#
# COMMON EXECUTION STARTS HERE
# (i.e. main())
# 

export    STAGE=$1
export    SID=$2
export    VERSION=${3:-0.0.0.0}
export    FSROOT=${4:-/}
export    BIN_PATH="${FSROOT}/usr/pkg/bin"
export    SBIN_PATH="${FSROOT}/usr/pkg/sbin"
export    RCD_PATH="${FSROOT}/usr/pkg/etc/rc.d"
export    ETC_PATH="${FSROOT}/usr/pkg/etc"
export    MAN_PATH="${FSROOT}/usr/pkg/man"

if [ -z "$STAGE" ]; then
    usage__
fi

if [ -z "$SID" ]; then
    usage__
fi

# XXX Add: known STAGE check
# XXX Add: known SID   check
# XXX Add: function    check if possible? 

#
# Stage Workarounds :-)
#

# rc.d compat

if [ "$STAGE" = "start" ]; then
    STAGE=startup
fi

if [ "$STAGE" = "stop" ]; then
    STAGE=shutdown
fi

# base.xml equivalence translations

if [ "$STAGE" = "restore" ]; then
    STAGE=startup
fi

if [ "$STAGE" = "save" ]; then
    STAGE=shutdown
fi

eval \${SID}_\${STAGE}
