#!/bin/sh

export chassiscli="admin agtcfgset agtcfgshow bannerset bannershow burninerrshow burninstatus celloporttest celloshow cfgadd cfgclear cfgcreate cfgdelete cfgdisable cfgenable cfgremove cfgsave cfgshow cfgsize cfgactvshow chassisshow clear configdefault configdownload configshow configupload configure configurezoning configzoningshow crossporttest date diaghelp diagpost diagportmailbox diagportmem diagportmemarm diagdisablepost diagenablepost diagsetburnin diagsetcycle diagstopburnin diagupload env errclear errshow eventactionset eventactionshow eventclear eventlogsize eventseverity eventseverityshow eventshow eventshowbynum exit fablogclear fablogshow fanshow fastboot fcipshow figeroshow firmwaredownload getdiaginfo h httpcfg help ifmodeset ifmodeshow install interfaceshow ipaddrset ipaddrshow iscsiportshow licenseadd licenseremove licenseshow linkcost lsdbshow mfg modinfo nbrstateshow nbrstatsclear netset netshow oemcfg passwd passwddefault patchk pdshow ping portcfgdefault portcfgeport portcfgfcip portcfgfullloop portcfggige portcfglongdistance portcfgspeed portcfgtopology portdiagclear portdiagenable portdiagdisable portdisable portenable porterrshow portlogclear portlogdisable portlogdump portlogenable portlogshow portloopbacktest portperfshow portrouteinfo portshow portstart portstatsshow portstop porttype portname ps psshow quit reboot rnping routeadd routedel routeshow rpgsrvr showrecovery saconf servicecfg setfanspeed setpageroff setpageron sfpshow sfpsupport slotshow spinsilk supportext supportshow svipaddrset svipaddrshow swaldisk switchdisable switchenable switchname switchstatusshow switchshow syslogdipadd syslogdipremove syslogdipshow tempshow timeout timezoneset top tsclockserver urouteconfig urouteremove urouteshow user users useradd userdel usershow uptime version voltshow wdogevt pkishow pkicreate pkiremove nv nvclean iscsitargetname fruinfoset"

export chassisman="admin agtcfgset agtcfgshow bannerset bannershow burninerrshow burninstatus celloporttest celloshow cfgadd cfgclear cfgcreate cfgdelete cfgdisable cfgenable cfgremove cfgsave cfgshow cfgsize cfgactvshow chassisshow clear configdefault configdownload configshow configupload configure configurezoning configzoningshow crossporttest date diaghelp diagpost diagportmailbox diagportmem diagportmemarm diagdisablepost diagenablepost diagsetburnin diagsetcycle diagstopburnin diagupload env errclear errshow eventactionset eventactionshow eventclear eventlogsize eventseverity eventseverityshow eventshow eventshowbynum exit fablogclear fablogshow fanshow fastboot fcipshow figeroshow firmwaredownload getdiaginfo h help ifmodeset ifmodeshow install interfaceshow ipaddrset ipaddrshow licenseadd licenseremove licenseshow linkcost lsdbshow mfg modinfo nbrstateshow nbrstatsclear netset netshow oemcfg passwd passwddefault pdshow ping portcfgdefault portcfgeport portcfgfcip portcfgfullloop portcfggige portcfglongdistance portcfgspeed portcfgtopology portdiagclear portdiagenable portdiagdisable portdisable portenable porterrshow portlogclear portlogdisable portlogdump portlogenable portlogshow portloopbacktest portperfshow portrouteinfo portshow portstart portstatsshow portstop porttype portname ps psshow quit reboot rnping routeadd routedel routeshow rpgsrvr showrecovery saconf setfanspeed setpageroff setpageron sfpshow sfpsupport slotshow spinsilk supportext supportshow svipaddrset svipaddrshow swaldisk switchdisable switchenable switchname switchstatusshow switchshow syslogdipadd syslogdipremove syslogdipshow tempshow timeout timezoneset top tsclockserver urouteconfig urouteremove urouteshow user users useradd userdel usershow uptime version voltshow wdogevt pkishow pkicreate pkiremove servicecfg iscsitargetname fruinfoset"

export fccli="aliadd alicreate alidelete aliremove alishow beacon csmsg_diag csmsg_stats dlsreset dlsset dlsshow fablogshow fablogclear zsdlogshow zsdlogclear fabricshow fspfshow iodreset iodset iodshow nsallshow nsshow nslogshow nslogclear topologyshow trunkreset trunkset trunkshow zoneadd zonecreate zonedelete zoneremove zoneshow fazoneadd fazonecreate fazonedelete fazoneremove fazoneshow qloopadd qloopcreate qloopdelete qloopremove qloopshow mslogshow mslogclear rcsinfoshow rcslogshow rcssmshow rcstoggle" 

export iswcli="fcrconfigure fcrproxydevshow fcrphydevshow fcrrouteshow fcrfabricshow fcrproxyconfig fcrxlateconfig lsanzoneshow portcfgexport fcrdbgdevshow fcrdbgportshow fcrdbgrouteshow fcrdbgmiscshow fcrdbgset fcrdbgshow fcrresourceshow fcrlastwwnclear fcrlastwwnshow fcrlastwwntest secauthsecret"

export diagcli="cellomemtest gmac2bridgetest ledtest asicrevshow diagmode sepromtest diagtempshow diagsfpshow diagpsshow diagfanshow diagvoltshow diagsetfanspeed diagchassissnshow diagboardsnshow diagportshow diagstartuppost diagshutdownpost"
          
export    STAGE=$1
export    SID=$2
export    VERSION=${3:-0.0.0.0}
export    FSROOT=${4:-/}
export    BIN_PATH="${FSROOT}/usr/pkg/bin"
export    SBIN_PATH="${FSROOT}/usr/pkg/sbin"
export    RCD_PATH="${FSROOT}/usr/pkg/etc/rc.d"
export    ETC_PATH="${FSROOT}/usr/pkg/etc"
export    MAN_PATH="${FSROOT}/usr/pkg/man"

# private variables

# --------------------------------------------------------------------------------------------------
# SERVICE SID: chassiscli
# 
chassiscli_pre_package() {
        rm -rf ${TMP_RPG_DIR}/chassiscli
        mkdir -p ${TMP_RPG_DIR}/chassiscli
        cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli \
                ${TMP_RPG_DIR}/chassiscli/rn_crunchclichassis

        for file in ${chassiscli}  ;
        do
                cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/cli/${file} ${TMP_RPG_DIR}/chassiscli
        done

        for i in `grep '^progs' ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli.conf | \
                awk '{print $2}'`
        do
            # go through all the cli that has crunched
            for j in ${chassiscli} ;
            do  
                if [ ${i} = ${j} ] ; then
                        # echo "got cli ${j}"
                        rm ${TMP_RPG_DIR}/chassiscli/${j}
                        ln ${TMP_RPG_DIR}/chassiscli/rn_crunchclichassis ${TMP_RPG_DIR}/chassiscli/$i
                fi      
            done
        done

	# copy version
	unlink ${TMP_RPG_DIR}/chassiscli/version
	cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/cli/rpgsrvr ${TMP_RPG_DIR}/chassiscli/version
        cd ${TMP_RPG_DIR}/chassiscli
        pax -v -w -f ../chassiscli.pax .
}   

chassiscli_post_install() {
        cd ${SBIN_PATH}
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: fccli
# 
fccli_pre_package() {
        rm -rf ${TMP_RPG_DIR}/fccli
        mkdir -p ${TMP_RPG_DIR}/fccli
        cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli \
                ${TMP_RPG_DIR}/fccli/rn_crunchclifc

        for file in ${fccli}  ;
        do
                cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/cli/${file} ${TMP_RPG_DIR}/fccli
        done

        for i in `grep '^progs' ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli.conf | \
                awk '{print $2}'`
        do
            # go through all the cli that has crunched
            for j in ${fccli} ;
            do
                if [ ${i} = ${j} ] ; then
                        # echo "got cli ${j}"
                        rm ${TMP_RPG_DIR}/fccli/${j}
                        ln ${TMP_RPG_DIR}/fccli/rn_crunchclifc ${TMP_RPG_DIR}/fccli/$i
                fi
            done
        done

        cd ${TMP_RPG_DIR}/fccli
        pax -w -f ../fccli.pax .
}


fccli_post_install() {
        cd ${SBIN_PATH}
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: chassisman
# 

chassisman_pre_package() {
        rm -fr ${TMP_RPG_DIR}/${SID}
	[ -f ${TMP_RPG_DIR}/${SID}.pax ] && rm -f ${TMP_RPG_DIR}/${SID}.pax
        mkdir -p ${TMP_RPG_DIR}/${SID}
        cd ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/man
        for i in ${chassisman} ;
        do
                cp ${i}.* ${TMP_RPG_DIR}/${SID}/.
        done

        cd ${TMP_RPG_DIR}/${SID}
        pax -v -x sv4crc -w -f ../${SID}.pax .
}

chassisman_post_install() {
        cd ${MAN_PATH}/man1
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
    chmod 755 ${MAN_PATH}
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: fcman
# 

fcman_pre_package() {
        rm -fr ${TMP_RPG_DIR}/${SID}
        mkdir -p ${TMP_RPG_DIR}/${SID}
	[ -f ${TMP_RPG_DIR}/${SID}.pax ] && rm -f ${TMP_RPG_DIR}/${SID}.pax
        cd ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/man
        for i in ${fccli} ;
        do
                cp ${i}.* ${TMP_RPG_DIR}/${SID}/.
        done

        cd ${TMP_RPG_DIR}/${SID}
        pax -v -x sv4crc -w -f ../${SID}.pax .
}

fcman_post_install() {
        cd ${MAN_PATH}/man1
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
    chmod 755 ${MAN_PATH}
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: iswcli
# 
iswcli_pre_package() {
        rm -rf ${TMP_RPG_DIR}/iswcli
        mkdir -p ${TMP_RPG_DIR}/iswcli
        cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli \
                ${TMP_RPG_DIR}/iswcli/rn_crunchcliisw

        for file in ${iswcli}  ;
        do
                cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/cli/${file} ${TMP_RPG_DIR}/iswcli
        done

        for i in `grep '^progs' ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli.conf | \
                awk '{print $2}'`
        do
            # go through all the cli that has crunched
            for j in ${iswcli} ;
            do
                if [ ${i} = ${j} ] ; then
                        # echo "got cli ${j}"
                        rm ${TMP_RPG_DIR}/iswcli/${j}
                        ln ${TMP_RPG_DIR}/iswcli/rn_crunchcliisw ${TMP_RPG_DIR}/iswcli/$i
                fi
            done
        done

        cd ${TMP_RPG_DIR}/iswcli
        pax -w -f ../iswcli.pax .
}


iswcli_post_install() {
        cd ${SBIN_PATH}
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: iswman
# 

iswman_pre_package() {
        rm -fr ${TMP_RPG_DIR}/${SID}
        mkdir -p ${TMP_RPG_DIR}/${SID}
	[ -f ${TMP_RPG_DIR}/${SID}.pax ] && rm -f ${TMP_RPG_DIR}/${SID}.pax
        cd ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/man
        for i in ${iswcli} ;
        do
                cp ${i}.* ${TMP_RPG_DIR}/${SID}/.
        done

        cd ${TMP_RPG_DIR}/${SID}
        pax -v -x sv4crc -w -f ../${SID}.pax .
}

iswman_post_install() {
        cd ${MAN_PATH}/man1
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
    chmod 755 ${MAN_PATH}
}

# --------------------------------------------------------------------------------------------------
# SERVICE SID: diagcli
# 
diagcli_pre_package() {
        rm -rf ${TMP_RPG_DIR}/diagcli
        mkdir -p ${TMP_RPG_DIR}/diagcli
        cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli \
                ${TMP_RPG_DIR}/diagcli/rn_crunchclifc

        for file in ${diagcli}  ;
        do
                cp ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/cli/${file} ${TMP_RPG_DIR}/diagcli
        done

        for i in `grep '^progs' ${BUILD_ROOT}/${HW_MODULE}/${ARCH}/crunch/rn_crunchcli.conf | \
                awk '{print $2}'`
        do
            # go through all the cli that has crunched
            for j in ${diagcli} ;
            do
                if [ ${i} = ${j} ] ; then
                        # echo "got cli ${j}"
                        rm ${TMP_RPG_DIR}/diagcli/${j}
                        ln ${TMP_RPG_DIR}/diagcli/rn_crunchclifc ${TMP_RPG_DIR}/diagcli/$i
                fi
            done
        done

        cd ${TMP_RPG_DIR}/diagcli
        pax -w -f ../diagcli.pax .
}


diagcli_post_install() {
    cd ${SBIN_PATH}
	pax -r -p e -f ${SID}.pax
	[ -f ${SID}.pax ] && rm -f ${SID}.pax
    
    mkdir -p ${FSROOT}/usr/pkg/diagscripts/cmddir

    cd ${SBIN_PATH}
    mv cellomemtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv gmac2bridgetest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv ledtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv asicrevshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagmode ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv sepromtest ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagvoltshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagfanshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagsfpshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagtempshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagpsshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagsetfanspeed ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagchassissnshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagboardsnshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagportshow ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagstartuppost ${FSROOT}/usr/pkg/diagscripts/cmddir/.
    mv diagshutdownpost ${FSROOT}/usr/pkg/diagscripts/cmddir/.    
}

eval ${SID}_${STAGE}
