#!/bin/sh

child=0


stop_child()
{
	if [ $child -ne 0 ]
	then
		/bin/kill -INT $child
	fi
	exit 0
}

perform_port_clear()
{
	port1=0
	while [ $port1 -lt 16 ]
	do
	   	portshowlog1=`/usr/pkg/diagscripts/cmddir/diagportshow $port1 |grep Diag`

		logdata1=`/bin/echo $portshowlog1  | /usr/bin/sed "s/\// /g"`
		logcnt1=`/bin/echo $logdata1 | /usr/bin/wc -w`
		i=1
		while [ $i -lt $logcnt1 ]
		do
		   logdata12=`/bin/echo $logdata1 | /usr/bin/cut -d" " -f$i`   
		   if [ "$logdata12" = ":" ]
		   then
		       num=`/bin/expr $i + 1`
		       status1=`/bin/echo $logdata1 | /usr/bin/cut -d" " -f$num`
		       if [ "$status1" = "FAILED" ]  
		       then
			/usr/pkg/sbin/portdiagclear $port1
		       fi
		   fi
		   i=`/bin/expr $i + 1`
		done	

	   port1=`/bin/expr $port1 + 1`
	done
	echo ""
}

trap stop_child INT TERM KILL

# This function take 3 arguments:
# 1. port number. If port number is 16, it means all ports are covered.
# 2. mem type. If mem type is 0, it means all types should be tested.

if [ $# -lt 2 ]
then
    exit 1
fi

if [ $1 -eq 16 ]
then
  port_run=16
  port_id=0
else
  port_run=`/bin/expr $1 + 1`
  port_id=$1 
fi

if [ $2 -eq 0 ]
then
  mbox_run=16
  mbox_id=1
else
  mbox_run=`/bin/expr $2 + 1`
  mbox_id=$2 
fi

logc=`perform_port_clear`
sleep 1

_d=`date` 
echo "$_d"
echo "$logc" 
total_ret=0
port_count=$port_id
while [ $port_count -lt $port_run ]
do

  mbox_count=$mbox_id
  while [ $mbox_count -lt $mbox_run ]
  do
    log=`/usr/pkg/sbin/diagportmailbox -p $port_count -m $mbox_count`
    ret=$?
    child=$!
    total_ret=`/bin/expr $total_ret + $ret`
    if [ ! -z "$log" ]
    then 
      echo "$log" 
    fi
    if [ "$ret" = "0" ]
    then
      echo "PASS diagportmailbox -p $port_count -m $mem_count $3"
      mbox_count=`/bin/expr $mbox_count + 1`
    else
      echo "FAIL diagportmailbix -p $port_count -m $mem_count $3"
      mbox_count=`/bin/expr $mbox_run + 1`
    fi
  done
  port_count=`/bin/expr $port_count + 1`
done

exit $total_ret
