#!/bin/sh
#
#

shutdown_non_ndsu()
{
    if [ -f  /usr/pkg/etc/rc.d/snmpd ]; then
	/usr/pkg/etc/rc.d/snmpd stop
    fi

    if [ -f  /usr/pkg/etc/rc.d/iscsid ]; then  
	/usr/pkg/etc/rc.d/iscsid stop
    fi

    if [ -f  /usr/pkg/etc/rc.d/apache ]; then 
	/usr/pkg/etc/rc.d/apache stop
    fi

    if [ -f  /usr/pkg/etc/rc.d/virtd ]; then 
	/usr/pkg/etc/rc.d/virtd stop
    fi

    if [ -f  /usr/pkg/etc/rc.d/sd ]; then 
	/usr/pkg/etc/rc.d/sd stop
    fi	

    if [ -f  /usr/pkg/etc/rc.d/overseer ]; then 
	/usr/pkg/etc/rc.d/overseer stop
    fi
}   

restart_non_ndsu()
{
    if [ -f  /usr/pkg/etc/rc.d/overseer ]; then 
	/usr/pkg/etc/rc.d/overseer restart
    fi

    if [ -f  /usr/pkg/etc/rc.d/sd ]; then 
	/usr/pkg/etc/rc.d/sd start
    fi	

    if [ -f  /usr/pkg/etc/rc.d/virtd ]; then 
	/usr/pkg/etc/rc.d/virtd start
    fi

    if [ -f  /usr/pkg/etc/rc.d/apache ]; then 
	/usr/pkg/etc/rc.d/apache start
    fi

    if [ -f  /usr/pkg/etc/rc.d/iscsid ]; then  
	/usr/pkg/etc/rc.d/iscsid start
    fi

    if [ -f  /usr/pkg/etc/rc.d/snmpd ]; then
	/usr/pkg/etc/rc.d/snmpd start
    fi

}

destroy_ramdisk()
{
    /sbin/umount /rpgtemp
}

rollback()
{
    # rename all the 'known' daemons back
    mv -f  $1/usr/pkg/bin/sb.old $1/usr/pkg/bin/sb
    mv -f  $1/usr/pkg/bin/evtmgr.old $1/usr/pkg/bin/evtmgr
    mv -f  $1/usr/pkg/bin/objmgr.old $1/usr/pkg/bin/objmgr
    mv -f  $1/usr/pkg/bin/chassisd.old $1/usr/pkg/bin/chassisd
    mv -f  $1/usr/pkg/bin/cpmgr.old $1/usr/pkg/bin/cpmgr
    mv -f  $1/usr/pkg/bin/iomctlr.old $1/usr/pkg/bin/iomctlr
    mv -f  $1/usr/pkg/bin/overseed.old $1/usr/pkg/bin/overseed
    mv -f  $1/usr/pkg/bin/nsd.old $1/usr/pkg/bin/nsd
    mv -f  $1/usr/pkg/bin/zsd.old $1/usr/pkg/bin/zsd
    mv -f  $1/usr/pkg/bin/fabctl.old $1/usr/pkg/bin/fabctl
    mv -f  $1/usr/pkg/bin/fcsald.old $1/usr/pkg/bin/fcsald

    destroy_ramdisk
    exit 2
}

create_ramdisk() {
	mkdir -p /rpgtemp                                  
        /sbin/mount_mfs -T mfs -s 20m /dev/md1a /rpgtemp
        if [ $? != 0 ]; then
		echo "Failed to create a ramdisk: NDSU abort"
		exit 2
	fi
}

upgrade_files()
{
        # NDSU specific install
        # rename all the 'known' daemons to *.old
        mv -f  $1/usr/pkg/bin/sb $1/usr/pkg/bin/sb.old
        mv -f  $1/usr/pkg/bin/evtmgr $1/usr/pkg/bin/evtmgr.old
        mv -f  $1/usr/pkg/bin/objmgr $1/usr/pkg/bin/objmgr.old
        mv -f  $1/usr/pkg/bin/chassisd $1/usr/pkg/bin/chassisd.old
        mv -f  $1/usr/pkg/bin/cpmgr $1/usr/pkg/bin/cpmgr.old
        mv -f  $1/usr/pkg/bin/iomctlr $1/usr/pkg/bin/iomctlr.old
        mv -f  $1/usr/pkg/bin/overseed $1/usr/pkg/bin/overseed.old
        mv -f  $1/usr/pkg/bin/nsd $1/usr/pkg/bin/nsd.old
        mv -f  $1/usr/pkg/bin/zsd $1/usr/pkg/bin/zsd.old
        mv -f  $1/usr/pkg/bin/fabctl $1/usr/pkg/bin/fabctl.old
        mv -f  $1/usr/pkg/bin/fcsald $1/usr/pkg/bin/fcsald.old
 
	# Move all the new binaries into the filesystem
        mv -f  /rpgtemp/usr/pkg/bin/sb $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/evtmgr $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/objmgr $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/chassisd $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/cpmgr $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/iomctlr $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/overseed $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/nsd $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/zsd $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/fabctl $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/fcsald $1/usr/pkg/bin/.
        mv -f  /rpgtemp/usr/pkg/bin/ud $1/usr/pkg/bin/.

	# Remove the binaries to free up space for checkpoints
        rm -f /rpgtemp/usr/pkg/bin/sb 
        rm -f /rpgtemp/usr/pkg/bin/evtmgr 
        rm -f /rpgtemp/usr/pkg/bin/objmgr 
        rm -f /rpgtemp/usr/pkg/bin/chassisd 
        rm -f /rpgtemp/usr/pkg/bin/cpmgr 
        rm -f /rpgtemp/usr/pkg/bin/iomctlr 
        rm -f /rpgtemp/usr/pkg/bin/overseed 
        rm -f /rpgtemp/usr/pkg/bin/nsd 
        rm -f /rpgtemp/usr/pkg/bin/zsd 
        rm -f /rpgtemp/usr/pkg/bin/fabctl 
        rm -f /rpgtemp/usr/pkg/bin/fcsald 
        rm -f /rpgtemp/usr/pkg/bin/ud 
}

upgrade_ndsu() 
{
#    /rpgtemp/usr/pkg/bin/ud -c /rpgtemp/usr/pkg/etc/ud_conf.xml -v -l /tmp/upgrade_log.txt
    /usr/pkg/bin/ud -c /etc/ud_conf.xml -v -l /tmp/upgrade_log.txt

# Internal: No rollbacks

#    case "$?" in
#	0)
#	    ;;
#	*)
#	    rollback
#	    exit $?
#	    ;;
#    esac

}

test_ndsu()
{
    create_ramdisk
    shutdown_non_ndsu
    upgrade_ndsu
    restart_non_ndsu
    destroy_ramdisk
    cat /tmp/upgrade_log.txt
}


usage()
{
    echo 1>&2 "Usage: $0 target_path src_path [install|upgrade]"
    exit 1
}


# Internal Use -- We only test.
test_ndsu
exit 0


if [ $1 = test ]; then
    test_ndsu
fi


case "$3" in    

	install)
	    (cd $1; cat $2/rhap-pkg2 | bunzip2 | pax -p e -r)
	    (cd $1/usr; cat $2/rhap-pkg3 | bunzip2 | pax -p e -r)
	    (cd $1; cat $2/rhap-pkg4 | bunzip2 | pax -p e -r)
	    ;;

	upgrade)
	    create_ramdisk
	    # extract the NDSU package into the playpen first
	    (cd /rpgtemp; cat $2/rhap-pkg4 | bunzip2 | pax -p e -r)
	    upgrade_files
	    shutdown_non_ndsu
	    upgrade_ndsu
	    restart_non_ndsu
	    destroy_ramdisk
	    ;;

	test_ndsu)
	    test
	    ;;
	*)
	    usage
	    ;;
esac
	